﻿Module Module1

    Sub Main()

        ' getCSharpDevelopersNames()
        ' queryWithJoin()
        ' queryWithWhereClause()
        ' getDevelopersNamesByLanguageAndAge()
        ' queryWithOrderByMultipleOrderingFields()
        ' implicitInnerJoinQuery()
        ' innerJoinQuery()

        Console.ReadLine()

    End Sub

    '
    ' Listing 2-2
    '
    Sub getCSharpDevelopersNames()

        Dim developers As Developer() = _
                {New Developer With {.Name = "Paolo", .Language = "C#"}, _
                New Developer With {.Name = "Marco", .Language = "C#"}, _
                New Developer With {.Name = "Frank", .Language = "VB.NET"}}

        Dim developersUsingCSharp As IEnumerable(Of String) = _
                From d In developers _
                Where d.Language = "C#" _
                Select d.Name

        For Each item In developersUsingCSharp
            Console.WriteLine(item)
        Next

    End Sub

    '
    ' Listing 2-6
    '
    Sub queryWithJoin()

        Dim customers As Customer() = { _
            New Customer With {.Name = "Paolo", .City = "Brescia", _
                .Orders = New Order() { _
                    New Order With {.IdOrder = 1, .EuroAmount = 100, .Description = "Order 1"}, _
                    New Order With {.IdOrder = 2, .EuroAmount = 150, .Description = "Order 2"}, _
                    New Order With {.IdOrder = 3, .EuroAmount = 230, .Description = "Order 3"} _
                }}, _
            New Customer With {.Name = "Marco", .City = "Torino", _
                .Orders = New Order() { _
                    New Order With {.IdOrder = 4, .EuroAmount = 320, .Description = "Order 4"}, _
                    New Order With {.IdOrder = 5, .EuroAmount = 170, .Description = "Order 5"} _
                }}}

        Dim ordersQuery = _
            From c In customers, _
            o In c.Orders _
            Select c.Name, o.IdOrder, o.EuroAmount

        For Each item In ordersQuery
            Console.WriteLine(item)
        Next

    End Sub

    '
    ' Listing 2-8
    '
    Sub queryWithWhereClause()

        Dim customers As Customer() = { _
            New Customer With {.Name = "Paolo", .City = "Brescia", _
                .Orders = New Order() { _
                    New Order With {.IdOrder = 1, .EuroAmount = 100, .Description = "Order 1"}, _
                    New Order With {.IdOrder = 2, .EuroAmount = 150, .Description = "Order 2"}, _
                    New Order With {.IdOrder = 3, .EuroAmount = 230, .Description = "Order 3"} _
                }}, _
            New Customer With {.Name = "Marco", .City = "Torino", _
                .Orders = New Order() { _
                    New Order With {.IdOrder = 4, .EuroAmount = 320, .Description = "Order 4"}, _
                    New Order With {.IdOrder = 5, .EuroAmount = 170, .Description = "Order 5"} _
                }}}

        Dim ordersQuery = _
            From c In customers, _
            o In c.Orders _
            Where o.EuroAmount > 200 _
            Select c.Name, o.IdOrder, o.EuroAmount

        For Each item In ordersQuery
            Console.WriteLine(item)
        Next

    End Sub

    '
    ' Listing 2-11
    '
    Sub getDevelopersNamesByLanguageAndAge()

        Dim developers As Developer() = _
                {New Developer With {.Name = "Paolo", .Language = "C#", .Age = 32}, _
                New Developer With {.Name = "Marco", .Language = "C#", .Age = 37}, _
                New Developer With {.Name = "Frank", .Language = "VB.NET", .Age = 48}}

        Dim developersGroupedByLanguage = _
                From d In developers _
                Group d By d.Language Into Group _
                Select Language, Group

        For Each group In developersGroupedByLanguage
            Console.WriteLine("Language: {0}", group.Language)
            For Each item In group.Group
                Console.WriteLine("    {0}", item.Name)
            Next
        Next

    End Sub

    '
    ' Listing 2-15
    '
    Sub queryWithOrderByMultipleOrderingFields()

        Dim customers As Customer() = { _
            New Customer With {.Name = "Paolo", .City = "Brescia", _
                .Orders = New Order() { _
                    New Order With {.IdOrder = 1, .EuroAmount = 100, .Description = "Order 1"}, _
                    New Order With {.IdOrder = 2, .EuroAmount = 150, .Description = "Order 2"}, _
                    New Order With {.IdOrder = 3, .EuroAmount = 230, .Description = "Order 3"} _
                }}, _
            New Customer With {.Name = "Marco", .City = "Torino", _
                .Orders = New Order() { _
                    New Order With {.IdOrder = 4, .EuroAmount = 320, .Description = "Order 4"}, _
                    New Order With {.IdOrder = 5, .EuroAmount = 170, .Description = "Order 5"} _
                }}}

        Dim ordersSortedByCustomerAndEuroAmount = _
            From c In customers, _
            o In c.Orders _
            Order By c.Name, o.EuroAmount Descending _
            Select c.Name, o.IdOrder, o.EuroAmount

        For Each item In ordersSortedByCustomerAndEuroAmount
            Console.WriteLine(item)
        Next

    End Sub

    '
    ' Listing 2-19
    '
    Sub implicitInnerJoinQuery()

        Dim categories As Category() = { _
                        New Category With {.IdCategory = 1, .Name = "Pasta"}, _
                        New Category With {.IdCategory = 2, .Name = "Beverages"}, _
                        New Category With {.IdCategory = 3, .Name = "Other food"} _
                    }

        Dim products As Product() = { _
            New Product With {.IdProduct = "PASTA01", .IdCategory = 1, .Description = "Tortellini"}, _
            New Product With {.IdProduct = "PASTA02", .IdCategory = 1, .Description = "Spaghetti"}, _
            New Product With {.IdProduct = "PASTA03", .IdCategory = 1, .Description = "Fusilli"}, _
            New Product With {.IdProduct = "BEV01", .IdCategory = 2, .Description = "Water"}, _
            New Product With {.IdProduct = "BEV02", .IdCategory = 2, .Description = "Orange Juice"} _
        }


        Dim categoriesAndProducts = _
            From c In categories, p In products _
            Where p.IdCategory = c.IdCategory _
            Select c.IdCategory, CategoryName = c.Name, Product = p.Description

        'Dim categoriesAndProducts = _
        '    From c In categories Join p In products On p.IdCategory Equals c.IdCategory _
        '    Select c.IdCategory, CategoryName = c.Name, Product = p.Description

        For Each item In categoriesAndProducts
            Console.WriteLine(item)
        Next

    End Sub

    '
    ' Listing 2-20
    '
    Sub innerJoinQuery()

        Dim categories As Category() = { _
                        New Category With {.IdCategory = 1, .Name = "Pasta"}, _
                        New Category With {.IdCategory = 2, .Name = "Beverages"}, _
                        New Category With {.IdCategory = 3, .Name = "Other food"} _
                    }

        Dim products As Product() = { _
            New Product With {.IdProduct = "PASTA01", .IdCategory = 1, .Description = "Tortellini"}, _
            New Product With {.IdProduct = "PASTA02", .IdCategory = 1, .Description = "Spaghetti"}, _
            New Product With {.IdProduct = "PASTA03", .IdCategory = 1, .Description = "Fusilli"}, _
            New Product With {.IdProduct = "BEV01", .IdCategory = 2, .Description = "Water"}, _
            New Product With {.IdProduct = "BEV02", .IdCategory = 2, .Description = "Orange Juice"} _
        }

        Dim categoriesAndProducts = _
            From c In categories Join p In products On p.IdCategory Equals c.IdCategory _
            Select c.IdCategory, CategoryName = c.Name, Product = p.Description

        For Each item In categoriesAndProducts
            Console.WriteLine(item)
        Next

    End Sub

End Module

Public Class Developer

    Public Name As String
    Public Language As String
    Public Age As Integer

End Class

Public Class Customer

    Public Name As String
    Public City As String
    Public Orders As Order()

End Class

Public Class Order

    Public IdOrder As Integer
    Public EuroAmount As Decimal
    Public Description As String

End Class

Public Class Category

    Public IdCategory As Integer
    Public Name As String

End Class

Public Class Product

    Public IdProduct As String
    Public IdCategory As Integer
    Public Description As String

End Class
